/**
 * Emulate FormData for some browsers
 * MIT License
 * (c) 2010 François de Metz
 */function Application(){function d(){var b=Date.now();a.onBeforeRender(b-c),c=b,a.renderManager.renderScene(a.scene,a.camera),a._nextFrame(d)}var a=this;this.renderManager=new RenderManager,this.scene=new Scene,this.camera=(new Camera).setPosition(new Vector3([0,0,10])),this.importer=new Importer("resources",function(b){a.scene.appendChild(b)}),this.exporter=new Exporter("resources"),this.input=new InputHandler,this.ui=new UIComponent,this.soundManager=new SoundManager(this.scene,this.camera),this.soundtrack=new SoundSource(this.scene),this.camera.appendChild(this.soundtrack),this.scene.appendChild(this.camera);var b=this.renderManager.renderer.canvas;this.setupCanvas(b),this._nextFrame=null,this.capFPS(60);var c=Date.now(),e=Date.now();setInterval(function(){var b=Date.now();a.soundManager.update(b-e),a.update(b-e),e=b},1e3/60),setTimeout(d,1)}function SoundManager(a,b){var c=this;this.scene=a,this.camera=b,this.bufferData={},this.scene.on("childadded",function d(a){if(a instanceof SoundSource)c.addSource(a);else for(var b=0;b<a.children.length;++b)d(a.children[b])}),this.scene.on("childremoved",function e(a){if(a instanceof SoundSource)c.removeSource(a);else for(var b=0;b<a.children.length;++b)e(a.children[b])}),this.playing={},this.callbacks={},webkitAudioContext&&(this.context=new webkitAudioContext,this.compressor=this.context.createDynamicsCompressor(),this.compressor.connect(this.context.destination))}function SoundSource(){SceneNode.call(this),this.nowPlaying=null,this.playAll=!1,this.velocity=new Vector3,this.uid=SoundSource.uid++,this.currentTrack=0,this.loop=SoundSource.LOOP_NONE,this.assets=[]}function SoundAsset(a){var b=this;EventEmitter.call(this),this.uid=SoundAsset.uid++,this.url=a,this.duration=NaN,this.tag=document.createElement("audio"),this.tag.src=a,this.tag.addEventListener("loadedmetadata",function(){b.duration=this.duration,b.emit("loadedmetadata")}),document.body.appendChild(this.tag)}function SoundLoader(){}function OBJLoader(){this.ready=!0;var a=this;this.mtlCache={},this.objCache={},this.pending=[]}function JSONLoader(){}function Importer(a,b){a[a.length-1]!=="/"&&(a+="/"),this.resourcePath=a,this.defaultCallback=b}function Exporter(a){a[a.length-1]!=="/"&&(a+="/"),this.resourcePath=a,this.isSaving=!1,this.pending=[]}function RenderManager(){this.renderer=new Renderer,this.forcedMaterial=null,this.postProcess=!1,this.framebuffer=new Framebuffer(this.renderer.width,this.renderer.height),this.renderer.getParameter(Renderer.FLOAT_TEXTURE)&&this.framebuffer.colorTexture.setDataType(Texture.FLOAT),this.postProcessEffects=[],this.quad=new Mesh,this.quad.setVertexAttribute((new VertexAttribute("UVCoord")).setBuffer((new Buffer).setData([-1,-1,1,1,-1,1,1,-1])).setSize(2)),this.quad.setIndexBuffer((new Buffer(Buffer.ELEMENT_BUFFER)).setData([0,1,2,0,3,1])),this.globalUniformCache={Time:Date.now(),ProjectionMatrix:new Matrix4,ViewMatrix:new Matrix4,WorldMatrix:new Matrix4,ViewProjectionMatrix:new Matrix4,WorldViewMatrix:new Matrix4,WorldViewProjectionMatrix:new Matrix4}}function UIComponent(){this.id=UUID.generateCanonicalForm()}function InputHandler(){this.enabled=!0,this.actions=[],this.devices=[],this.keyboard=new Keyboard,this.addDevice(this.keyboard),this.mouse=new Mouse,this.addDevice(this.mouse)}function Mouse(){this.down={},this.prevX=0,this.prevY=0,this.actions={},window.addEventListener("mousedown",Mouse.prototype.handleMouseDown.bind(this),!1),window.addEventListener("mouseup",Mouse.prototype.handleMouseUp.bind(this),!1),window.addEventListener("mousemove",Mouse.prototype.handleMouseMove.bind(this),!1),window.addEventListener("mousewheel",Mouse.prototype.handleMouseWheel.bind(this),!1),window.addEventListener("DOMMouseScroll",Mouse.prototype.handleMouseWheel.bind(this),!1)}function Keyboard(){this.actions={},this.keyData={},this.pressed={},window.addEventListener("keydown",Keyboard.prototype.handleKeyDown.bind(this),!1),window.addEventListener("keyup",Keyboard.prototype.handleKeyUp.bind(this),!1),document.addEventListener("mouseout",Keyboard.prototype.handleMouseOut.bind(this),!1)}function InputDevice(){}function Sphere(a,b,c){Drawable.call(this),a=a||1,b=b||10,c=c||b;var d=a,e=b,f=c,g={vertices:[],indices:[]},h=function(a,b){return a===0?b-1:a-1},i,j,k,l,m=0,n=0;for(var o=1;o<e-1;o++){i=d*Math.sin(-Math.PI/2+o*Math.PI/(e-1)),l=d*Math.cos(-Math.PI/2+o*Math.PI/(e-1));for(var p=0;p<f;p++)j=l*Math.cos(2*Math.PI*p/f),k=l*Math.sin(2*Math.PI*p/f),g.vertices[m]=j,g.vertices[m+1]=i,g.vertices[m+2]=k,m=m+3;if(o>1){var q=(o-2)*f;for(j=0;j<f;j++)g.indices[n]=q+j,g.indices[n+1]=q+h(j,f)+f,g.indices[n+2]=q+j+f,n+=3,g.indices[n]=q+j,g.indices[n+1]=q+h(j,f),g.indices[n+2]=q+h(j,f)+f,n+=3}}g.vertices[m]=0,g.vertices[m+1]=-d,g.vertices[m+2]=0;var r=m/3;m+=3,g.vertices[m]=0,g.vertices[m+1]=d,g.vertices[m+2]=0,m+=3;var s=r+1;for(j=0;j<f;j++)g.indices[n]=r,g.indices[n+1]=h(j,f),g.indices[n+2]=j,n+=3,g.indices[n]=r-f+j,g.indices[n+1]=r-f+h(j,f),g.indices[n+2]=s,n+=3;var t=(new Buffer).setData(g.vertices);t=(new VertexAttribute("Position")).setBuffer(t);var u=(new Buffer(Buffer.ELEMENT_BUFFER)).setData(g.indices);f=new Mesh,f.setVertexAttribute(t),f.setIndexBuffer(u),this.mesh=f}function Rectangle(a,b,c,d){Drawable.call(this);var e=[a,0,b,c,0,b,a,0,d,c,0,d],f=[0,0,0,1,1,0,1,1],g=[0,1,0,0,1,0,0,1,0,0,1,0],h=[0,1,2,2,1,3];e=(new Buffer).setData(e),f=(new Buffer).setData(f),g=(new Buffer).setData(g),e=(new VertexAttribute("Position")).setBuffer(e),f=(new VertexAttribute("UVCoord")).setBuffer(f).setSize(2),g=(new VertexAttribute("Normal")).setBuffer(g),h=(new Buffer(Buffer.ELEMENT_BUFFER)).setData(h);var i=new Mesh;i.setVertexAttribute(e),i.setVertexAttribute(g),i.setVertexAttribute(f),i.setIndexBuffer(h),this.mesh=i}function Cube(){function i(c,d){f.vertices.push(a[c*3*4+d*3],a[c*3*4+d*3+1],a[c*3*4+d*3+2]),f.uvcoords.push(b[d*2],b[d*2+1])}Drawable.call(this);var a=[1,0,0,1,1,1,1,0,1,1,1,0,0,1,0,0,0,1,0,1,1,0,0,0,0,1,0,1,1,1,1,1,0,0,1,1,0,0,1,1,0,0,1,0,1,0,0,0,0,0,1,1,1,1,0,1,1,1,0,1,1,0,0,0,1,0,1,1,0,0,0,0],b=[0,0,1,1,0,1,1,0],c=[1,0,0,-1,0,0,0,1,0,0,-1,0,0,0,1,0,0,-1],d=[0,1,0,0,-1,0,0,0,1,0,0,-1,1,0,0,-1,0,0];for(var e=0;e<a.length;++e)a[e]-=.5;var f={vertices:[],indices:[],normals:[],tangents:[],uvcoords:[]};for(var g=0;g<6;++g)for(var h=0;h<6;++h)f.normals.push(c[g*3],c[g*3+1],c[g*3+2]),f.tangents.push(d[g*3],d[g*3+1],d[g*3+2]),f.indices.push(g*6+h);for(g=0;g<6;++g)i(g,0),i(g,1),i(g,2),i(g,0),i(g,3),i(g,1);a=(new Buffer).setData(f.vertices),b=(new Buffer).setData(f.uvcoords),c=(new Buffer).setData(f.normals),a=(new VertexAttribute("Position")).setBuffer(a),b=(new VertexAttribute("UVCoord")).setBuffer(b).setSize(2),c=(new VertexAttribute("Normal")).setBuffer(c);var j=(new Buffer(Buffer.ELEMENT_BUFFER)).setData(f.indices),k=new Mesh;k.setVertexAttribute(a),k.setVertexAttribute(c),k.setVertexAttribute(b),k.setIndexBuffer(j),this.mesh=k}function TexturedMaterial(){Material.call(this),this.name="TexturedMaterial";var a=this;(new Importer("resources")).load("system/TexturedShader",function(b){a.shader=b}),this.engineParameters={WorldViewProjectionMatrix:!0,WorldViewMatrix:!0}}function BasicMaterial(){Material.call(this),this.name="BasicMaterial";var a=this;(new Importer("resources")).load("system/BasicShader",function(b){a.shader=b}),this.setParameter("Diffuse",new Vector3([1,1,1])),this.engineParameters={WorldViewProjectionMatrix:!0}}function Material(){this.uuid=UUID.generateCanonicalForm(),this.uid=Material.uid++,this.name=this.uuid,this.shader=null,this.parameters={}}function Scene(){SceneNode.call(this),this.drawableList=[]}function Light(){SceneNode.call(this)}function Drawable(){SceneNode.call(this),this.mesh=null,this.material=new BasicMaterial}function Camera(){SceneNode.call(this),this.width=1,this.height=1,this.ratio=1,this.zNear=.1,this.zFar=1e3,this.fieldOfView=55,this.tanFieldOfView=Math.tan(this.fieldOfView/2*(Math.PI/180)),this.cosFieldOfView=Math.cos(this.fieldOfView/2*(Math.PI/180)),this.horizontalTanFieldOfView=this.tanFieldOfView,this.horizontalCosFieldOfview=Math.cos(Math.atan(this.tanFieldOfView)),this.projectionMatrix=new Matrix4,this.setPerspective()}function SceneNode(){this.uuid=UUID.generateCanonicalForm(),this.parent=SceneNode.Origin,this.children=[],this.worldTransform=new Transform,this.name=this.uuid,this.boundingVolume=new BoundingSphere,Transform.call(this),EventEmitter.call(this)}function BoundingBox(){this.halfExtent=new Vector3}function BoundingSphere(){this.radius=1}function Framebuffer(a,b){this.uid=Framebuffer.uid++,this.width=a||256,this.height=b||256,this.colorTexture=(new Texture).setWrapS(Texture.CLAMP_TO_EDGE).setWrapT(Texture.CLAMP_TO_EDGE).setFormat(Texture.RGBA),this.needsUpdate=!0}function Shader(){this.uid=Shader.uid++,this.uuid=UUID.generateCanonicalForm(),this.name=this.uuid,this.vertexSource="",this.fragmentSource="",this.uniforms={},this.needsUpdate=!1}function Mesh(){this.uuid=UUID.generate(),this.name=this.uuid,this.mode=Mesh.TRIANGLES,this.vertexAttributes={},this.indexBuffer=null}function Texture(a){this.uid=Texture.uid++,this.uuid=UUID.generateCanonicalForm(),this.name=this.uuid,this.width=1,this.height=1,this.minFilter=Texture.LINEAR,this.magFilter=Texture.LINEAR,this.type=a||Texture.IMAGE,this.wrapS=Texture.CLAMP_TO_EDGE,this.wrapT=Texture.CLAMP_TO_EDGE,this.format=Texture.RGB,this.dataType=Texture.UNSIGNED_BYTE,this.origin=Texture.UPPER_LEFT_CORNER,this.source=null,this.needsUpdate=!0}function VertexAttribute(a){this.uuid=UUID.generateCanonicalForm(),this.name=this.uuid,this.semantic=a||"",this.stride=0,this.size=3,this.offset=0,this.length=0,this.buffer=null}function Buffer(a,b){this.uuid=UUID.generateCanonicalForm(),this.name=this.uuid,this.uid=Buffer.uid++,this.data=null,this.length=0,this.usage=b||Buffer.STATIC,this.type=a||Buffer.DATA_BUFFER,this.needsUpdate=!0}function Color(a){return Vector3.call(this,a)}function Transform(){this.position=new Vector3,this.orientation=new Quaternion,this.scale=1,this._invalidate(),this.matrix=new Matrix4}function Quaternion(a){this.data=new Float32Array(4),a?a.data?this.data.set(a.data):this.data.set(a):this.data[3]=1}function Vector3(a){this.data=new Float32Array(3),a&&(a.data?this.data.set(a.data):this.data.set(a))}function Matrix3(a){this.data=new Float32Array(9),a?a.data?this.data.set(a.data):this.data.set(a):this.setIdentity()}function Matrix4(a){this.data=new Float32Array(16),a?a.data?this.data.set(a.data):this.data.set(a):Matrix4.identity(this)}function EventWaiter(){this._waitingList=[],EventEmitter.call(this)}function EventEmitter(){this._events_=[]}function Request(){}function TempVars(){}function UUID(){}function makeRequestAnimationFrame(){function a(a){window.setTimeout(a,1e3/60)}return typeof window.webkitRequestAnimationFrame!="undefined"?window.webkitRequestAnimationFrame:typeof window.mozRequestAnimationFrame!="undefined"?window.mozRequestAnimationFrame:typeof window.oRequestAnimationFrame!="undefined"?window.oRequestAnimationFrame:typeof window.msRequestAnimationFrame!="undefined"?window.msRequestAnimationFrame:a}function assertIn(a){for(var b=1;b<arguments.length-1;++b)if(a==arguments[b])return;throw arguments[arguments.length-1]}function assert(a,b){if(!a)throw b}(function(a){function b(){this.fake=!0,this.boundary="--------FormData"+Math.random(),this._fields=[]}a.FormData||(b.prototype.append=function(a,b){this._fields.push([a,b])},b.prototype.toString=function(){var a=this.boundary,b="";this._fields.forEach(function(c){b+="--"+a+"\r\n",b+='Content-Disposition: form-data; name="'+c[0]+'";\r\n\r\n',b+=c[1]+"\r\n"}),b+="--"+a+"--";return b},a.FormData=b)})(window);var debug={TRACE:0,WARNING:1,ERROR:2,log:function(a,b){console.log(b)}};Object.defineProperty(Function.prototype,"extend",{value:function(){var a,b=arguments.length;while(b--){var c=arguments[b];for(a in c.prototype){if(a=="constructor")continue;var d=Object.getOwnPropertyDescriptor(c.prototype,a);d!==null&&(this.prototype.hasOwnProperty(a)?Object.defineProperty(this.prototype,c.name+"_"+a,d):Object.defineProperty(this.prototype,a,d))}}var e={};for(a in this.prototype)e[a]=Object.getOwnPropertyDescriptor(this.prototype,a);this.prototype=Object.create(arguments[0].prototype,e)}}),window.requestAnimationFrame||(window.requestAnimationFrame=makeRequestAnimationFrame()),Object.defineProperty(Float32Array.prototype,"toArray",{value:function(){var a=this.length,b=[];while(a--)b[a]=this[a];return b}}),Object.defineProperty(Uint16Array.prototype,"toArray",{value:function(){var a=this.length,b=[];while(a--)b[a]=this[a];return b}}),Object.defineProperty(Number.prototype,"isPowerOfTwo",{value:function(){return this>0&&(this&this-1)===0}}),UUID.generate=function(){var a="",b,c,d;for(b=0;b<16;++b)b==6?(d=64,c=79):b==8?(d=128,c=191):(d=0,c=256),a+=String.fromCharCode(Math.floor(Math.random()*(c-d)+d));return a},UUID.generateCanonicalForm=function(){return"xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g,function(a){var b=Math.random()*16|0,c=a=="x"?b:b&3|8;return c.toString(16)})},UUID.toCanonicalForm=function(a){var b="",c;for(var d=0;d<16;++d){if(d==4||d==6||d==8||d==10)b+="-";c=a.charCodeAt(d).toString(16),c.length==1&&(c="0"+c),b+=c}return b},UUID.fromCanonicalForm=function(a){var b="",c;a=a.replace(/-/g,"");for(c=0;c<16;++c)b+=String.fromCharCode(parseInt(a[c*2]+a[c*2+1],16));return b},TempVars.lock=function(){TempVars.vector3ReleasePoints.push(TempVars.vector3Counter),TempVars.matrix4ReleasePoints.push(TempVars.matrix4Counter),TempVars.matrix3ReleasePoints.push(TempVars.matrix3Counter),TempVars.quaternionReleasePoints.push(TempVars.quaternionCounter)},TempVars.release=function(){TempVars.vector3Counter=TempVars.vector3ReleasePoints.pop(),TempVars.matrix4Counter=TempVars.matrix4ReleasePoints.pop(),TempVars.matrix3Counter=TempVars.matrix3ReleasePoints.pop(),TempVars.quaternionCounter=TempVars.quaternionReleasePoints.pop()},TempVars.vector3ReleasePoints=[],TempVars.vector3Counter=0,TempVars.vector3Stack=[],TempVars.getVector3=function(){var a=TempVars.vector3Stack[TempVars.vector3Counter++];a||(a=TempVars.vector3Stack[TempVars.vector3Counter-1]=new Vector3);return a},TempVars.matrix4ReleasePoints=[],TempVars.matrix4Counter=0,TempVars.matrix4Stack=[],TempVars.getMatrix4=function(){var a=TempVars.matrix4Stack[TempVars.matrix4Counter++];a||(a=TempVars.matrix4Stack[TempVars.matrix4Counter-1]=new Matrix4);return a},TempVars.matrix3ReleasePoints=[],TempVars.matrix3Counter=0,TempVars.matrix3Stack=[],TempVars.getMatrix3=function(){var a=TempVars.matrix3Stack[TempVars.matrix3Counter++];a||(a=TempVars.matrix3Stack[TempVars.matrix3Counter-1]=new Matrix3);return a},TempVars.quaternionReleasePoints=[],TempVars.quaternionCounter=0,TempVars.quaternionStack=[],TempVars.getQuaternion=function(){var a=TempVars.quaternionStack[TempVars.quaternionCounter++];a||(a=TempVars.quaternionStack[TempVars.quaternionCounter-1]=new Quaternion);return a},Request.send=function(a,b,c,d){typeof c=="function"&&(d=c,c=null);var e=new FormData;if(c)for(var f in c)e.append(f,c[f]);var g=new XMLHttpRequest;g.open(a,b),d&&(g.onreadystatechange=function(){g.readyState==4&&d(g.responseText)}),g.send(e)},Request.get=function(a,b,c){Request.send("GET",a,b,c)},Request.post=function(a,b,c){Request.send("POST",a,b,c)},EventEmitter.prototype={constructor:EventEmitter,on:function(a,b){a in this._events_||(this._events_[a]=[]),this._events_[a].push(b)},once:function(a,b){b.once=!0,this.on(a,b)},clearListeners:function(a){this._events_[a]=[]},emit:function(a){var b=Array.prototype.slice.call(arguments,1),c=this._events_[a];if(!!c)for(var d in c){var e=c[d];e.apply(this,b);if(e.once){c.splice(d,1);if(!c.length)break;--d}}},removeListener:function(a,b){if(!this._events_[a])return!1;var c=this._events_[a];for(var d=0,e=c.length;d<e;d++)if(c[d]===b){c.splice(d,1);return!0}return!1}},EventWaiter.prototype={constructor:EventWaiter,isWaiting:function(){return this._waitingList.length},wait:function(a,b,c){this.waitMore(c);var d=this;a.once(b,function(){d.waitLess(c)})},waitTimed:function(a,b,c,d){this.waitMore(d);var e=this,f=setTimeout(function(){e.waitLess(d)},c);a.once(b,function(){setTimeout(function(){e.waitLess(d),clearTimeout(f)},0)})},callback:function(a){this.waitMore(a);var b=this;return function(){b.waitLess(a)}},waitMore:function(a){a=a||"",this._waitingList.push(a)},waitLess:function(a){var b=this._waitingList.indexOf(a);this._waitingList.splice(b,1),this.emit("one",a),this._waitingList.length||this.emit("complete")},isComplete:function(){return!!this._waitingList.length},getWaitingList:function(){return this._waitingList}},EventWaiter.extend(EventEmitter),Matrix4.prototype={constructor:Matrix4,set:function(a){if(a instanceof Array)throw"error";this.data.set(a.data);return this},copyTo:function(a){if(a instanceof Array)throw"error";a.data.set(this.data);return a},getTranslation:function(a){a||(a=new Vector3);var b=this.data,c=a.data;c[0]=b[12],c[1]=b[13],c[2]=b[14];return a},getRotationMatrix:function(a){a||(a=new Matrix4);var b=this.data,c=a.data;c[0]=b[0],c[1]=b[1],c[2]=b[2],c[3]=b[4],c[4]=b[5],c[5]=b[6],c[6]=b[8],c[7]=b[9],c[8]=b[10];return a},transpose:function(){var a=this.data,b=a[1],c=a[2],d=a[3],e=a[6],f=a[7],g=a[11];a[1]=a[4],a[2]=a[8],a[3]=a[12],a[4]=b,a[6]=a[9],a[7]=a[13],a[8]=c,a[9]=e,a[11]=a[14],a[12]=d,a[13]=f,a[14]=g;return this},getDeterminant:function(){var a=this.data,b=a[0],c=a[1],d=a[2],e=a[3],f=a[4],g=a[5],h=a[6],i=a[7],j=a[8],k=a[9],l=a[10],m=a[11],n=a[12],o=a[13],p=a[14],q=a[15];return n*k*h*e-j*o*h*e-n*g*l*e+f*o*l*e+j*g*p*e-f*k*p*e-n*k*d*i+j*o*d*i+n*c*l*i-b*o*l*i-j*c*p*i+b*k*p*i+n*g*d*m-f*o*d*m-n*c*h*m+b*o*h*m+f*c*p*m-b*g*p*m-j*g*d*q+f*k*d*q+j*c*h*q-b*k*h*q-f*c*l*q+b*g*l*q},inverse:function(){var a=this.data,b=a[0],c=a[1],d=a[2],e=a[3],f=a[4],g=a[5],h=a[6],i=a[7],j=a[8],k=a[9],l=a[10],m=a[11],n=a[12],o=a[13],p=a[14],q=a[15],r=b*g-c*f,s=b*h-d*f,t=b*i-e*f,u=c*h-d*g,v=c*i-e*g,w=d*i-e*h,x=j*o-k*n,y=j*p-l*n,z=j*q-m*n,A=k*p-l*o,B=k*q-m*o,C=l*q-m*p,D=1/(r*C-s*B+t*A+u*z-v*y+w*x);a[0]=(g*C-h*B+i*A)*D,a[1]=(-c*C+d*B-e*A)*D,a[2]=(o*w-p*v+q*u)*D,a[3]=(-k*w+l*v-m*u)*D,a[4]=(-f*C+h*z-i*y)*D,a[5]=(b*C-d*z+e*y)*D,a[6]=(-n*w+p*t-q*s)*D,a[7]=(j*w-l*t+m*s)*D,a[8]=(f*B-g*z+i*x)*D,a[9]=(-b*B+c*z-e*x)*D,a[10]=(n*v-o*t+q*r)*D,a[11]=(-j*v+k*t-m*r)*D,a[12]=(-f*A+g*y-h*x)*D,a[13]=(b*A-c*y+d*x)*D,a[14]=(-n*u+o*s-p*r)*D,a[15]=(j*u-k*s+l*r)*D;return this},multiply:function(a){var b=this.data,c=a.data,d=b[0],e=b[1],f=b[2],g=b[3],h=b[4],i=b[5],j=b[6],k=b[7],l=b[8],m=b[9],n=b[10],o=b[11],p=b[12],q=b[13],r=b[14],s=b[15],t=c[0],u=c[1],v=c[2],w=c[3],x=c[4],y=c[5],z=c[6],A=c[7],B=c[8],C=c[9],D=c[10],E=c[11],F=c[12],G=c[13],H=c[14],I=c[15];b[0]=t*d+u*h+v*l+w*p,b[1]=t*e+u*i+v*m+w*q,b[2]=t*f+u*j+v*n+w*r,b[3]=t*g+u*k+v*o+w*s,b[4]=x*d+y*h+z*l+A*p,b[5]=x*e+y*i+z*m+A*q,b[6]=x*f+y*j+z*n+A*r,b[7]=x*g+y*k+z*o+A*s,b[8]=B*d+C*h+D*l+E*p,b[9]=B*e+C*i+D*m+E*q,b[10]=B*f+C*j+D*n+E*r,b[11]=B*g+C*k+D*o+E*s,b[12]=F*d+G*h+H*l+I*p,b[13]=F*e+G*i+H*m+I*q,b[14]=F*f+G*j+H*n+I*r,b[15]=F*g+G*k+H*o+I*s;return this},multiplyVector3:function(a){var b=this.data,c=a.data,d=c[0],e=c[1],f=c[2];c[0]=b[0]*d+b[4]*e+b[8]*f+b[12],c[1]=b[1]*d+b[5]*e+b[9]*f+b[13],c[2]=b[2]*d+b[6]*e+b[10]*f+b[14];return a},clone:function(){return new Matrix4(this)}},Matrix4.identity=function(a){a||(a=new Matrix4);var b=a.data;b[0]=1,b[1]=0,b[2]=0,b[3]=0,b[4]=0,b[5]=1,b[6]=0,b[7]=0,b[8]=0,b[9]=0,b[10]=1,b[11]=0,b[12]=0,b[13]=0,b[14]=0,b[15]=1;return a},Matrix4.frustrum=function(a,b,c,d,e,f,g){g||(g=new Matrix4);var h=g.data,i=b-a,j=d-c,k=f-e;h[0]=e*2/i,h[1]=0,h[2]=0,h[3]=0,h[4]=0,h[5]=e*2/j,h[6]=0,h[7]=0,h[8]=(b+a)/i,h[9]=(d+c)/j,h[10]=-(f+e)/k,h[11]=-1,h[12]=0,h[13]=0,h[14]=-(f*e*2)/k,h[15]=0;return g},Matrix4.perspective=function(a,b,c,d,e){var f=c*Math.tan(a*Math.PI/360),g=f*b;return Matrix4.frustrum(-g,g,-f,f,c,d,e)},Matrix4.ortho=function(a,b,c,d,e,f,g){g||(g=new Matrix4);var h=g.data,i=b-a,j=d-c,k=f-e;h[0]=2/i,h[1]=0,h[2]=0,h[3]=0,h[4]=0,h[5]=2/j,h[6]=0,h[7]=0,h[8]=0,h[9]=0,h[10]=-2/k,h[11]=0,h[12]=-(a+b)/i,h[13]=-(d+c)/j,h[14]=-(f+e)/k,h[15]=1;return g},Matrix3.prototype={constructor:Matrix3,set:function(a){if(a instanceof Array)throw"error";this.data.set(a.data);return this},setIdentity:function(){var a=this.data;a[0]=1,a[1]=0,a[2]=0,a[3]=0,a[4]=1,a[5]=0,a[6]=0,a[7]=0,a[8]=1;return this},clone:function(){return new Matrix3(this)}},Vector3.prototype={constructor:Vector3,set:function(a){if(a instanceof Array)throw"error";this.data.set(a.data);return this},copyTo:function(a){if(a instanceof Array)throw"error";a.data.set(this.data);return a},add:function(a){var b=this.data,c=a.data;b[0]+=c[0],b[1]+=c[1],b[2]+=c[2];return this},subtract:function(a){var b=this.data,c=a.data;b[0]-=c[0],b[1]-=c[1],b[2]-=c[2];return this},negate:function(){var a=this.data;a[0]=-a[0],a[1]=-a[1],a[2]=-a[2];return this},scale:function(a){var b=this.data;b[0]*=a,b[1]*=a,b[2]*=a;return this},normalize:function(){var a=this.data,b=a[0],c=a[1],d=a[2],e=Math.sqrt(b*b+c*c+d*d);if(e===0){a[0]=0,a[1]=0,a[2]=0;return this}e=1/e,a[0]*=e,a[1]*=e,a[2]*=e;return this},cross:function(a){var b=this.data,c=a.data,d=b[0],e=b[1],f=b[2],g=c[0],h=c[1],i=c[2];b[0]=e*i-f*h,b[1]=f*g-d*i,b[2]=d*h-e*g;return this},length:function(){var a=this.data,b=a[0],c=a[1],d=a[2];return Math.sqrt(b*b+c*c+d*d)},length2:function(){var a=this.data,b=a[0],c=a[1],d=a[2];return b*b+c*c+d*d},dot:function(a){var b=this.data,c=a.data;return b[0]*c[0]+b[1]*c[1]+b[2]*c[2]},absolute:function(){var a=this.data;a[0]<0&&(a[0]=-a[0]),a[1]<0&&(a[1]=-a[1]),a[2]<0&&(a[2]=-a[2]);return this},clone:function(){return new Vector3(this)},get x(){return this.data[0]},set x(a){this.data[0]=a},get y(){return this.data[1]},set y(a){this.data[1]=a},get z(){return this.data[2]},set z(a){this.data[2]=a},toString:function(){return"["+[this.data[0],this.data[1],this.data[2]]+"]"}},Quaternion.prototype={constructor:Quaternion,set:function(a){if(a instanceof Array)throw"error";this.data.set(a.data);return this},copyTo:function(a){if(a instanceof Array)throw"error";a.data.set(this.data);return a},setEuler:function(a,b,c){var d=this.data;a*=.5,b*=.5,c*=.5;var e=Math.cos,f=Math.sin,g=e(a),h=f(a),i=e(b),j=f(b),k=e(c),l=f(c);d[0]=k*j*g+l*i*h,d[1]=k*i*h-l*j*g,d[2]=l*i*g-k*j*h,d[3]=k*i*g+l*j*h;return this},setAxisAngle:function(a,b){b*=.5,TempVars.lock();var c=this.data,d=TempVars.getVector3();d.set(a).normalize().scale(Math.sin(b)),c[0]=d.data[0],c[1]=d.data[1],c[2]=d.data[2],c[3]=Math.cos(b),TempVars.release();return this},getAngle:function(){var a=this.data;if(a[0]||a[1]||a[2]){var b=Math.acos(a[3]);if(b<-1)return 2*Math.PI;if(b>1)return 0;return 2*Math.acos(b)}return 0},getAxis:function(a){var b=this.data;a||(a=new Vector3),b[0]||b[1]||b[2]?(a.data[0]=b[0],a.data[1]=b[1],a.data[2]=b[2],a.normalize()):(a.data[0]=0,a.data[1]=0,a.data[2]=1);return a},getAxisAngle:function(a){var b=this.data;a||(a=new Vector3),a.data[0]=Math.atan2(2*(b[3]*b[0]+b[1]*b[2]),1-2*(b[0]*b[0]+b[1]*b[1])),a.data[1]=Math.asin(2*(b[3]*b[1]-b[2]*b[0])),a.data[2]=Math.atan2(2*(b[3]*b[2]+b[0]*b[1]),1-2*(b[1]*b[1]+b[2]*b[2]));return a},inverse:function(){var a=this.data;a[0]=-a[0],a[1]=-a[1],a[2]=-a[2];return this},multiply:function(a){var b=this.data,c=a.data,d=b[0],e=b[1],f=b[2],g=b[3],h=c[0],i=c[1],j=c[2],k=c[3];b[0]=d*k+g*h+e*j-f*i,b[1]=e*k+g*i+f*h-d*j,b[2]=f*k+g*j+d*i-e*h,b[3]=g*k-d*h-e*i-f*j;return this},preMultiply:function(a){var b=this.data,c=a.data,d=b[0],e=b[1],f=b[2],g=b[3],h=c[0],i=c[1],j=c[2],k=c[3];b[0]=h*g+k*d+i*f-j*e,b[1]=i*g+k*e+j*d-h*f,b[2]=j*g+k*f+h*e-i*d,b[3]=k*g-h*d-i*e-j*f;return this},multiplyVector3:function(a){var b=this.data,c=a.data,d=c[0],e=c[1],f=c[2],g=b[0],h=b[1],i=b[2],j=b[3],k=j*d+h*f-i*e,l=j*e+i*d-g*f,m=j*f+g*e-h*d,n=-g*d-h*e-i*f;c[0]=k*j+n*-g+l*-i-m*-h,c[1]=l*j+n*-h+m*-g-k*-i,c[2]=m*j+n*-i+k*-h-l*-g;return a},fromMatrix3:function(a){var b=this.data,c=a.data,d,e=c[0]+c[4]+c[8];e>=0?(d=Math.sqrt(e+1),b[3]=.5*d,d=.5/d,b[0]=(c[5]-c[7])*d,b[1]=(c[6]-c[2])*d,b[2]=(c[1]-c[3])*d):c[0]>c[4]&&c[0]>c[8]?(d=Math.sqrt(1+c[0]-c[4]-c[8]),b[0]=d*.5,d=.5/d,b[1]=(c[1]+c[3])*d,b[2]=(c[6]+c[2])*d,b[3]=(c[5]-c[7])*d):c[4]>c[8]?(d=Math.sqrt(1+c[4]-c[0]-c[8]),b[1]=d*.5,d=.5/d,b[0]=(c[1]+c[3])*d,b[2]=(c[5]+c[7])*d,b[3]=(c[6]-c[2])*d):(d=Math.sqrt(1+c[8]-c[0]-c[4]),b[2]=d*.5,d=.5/d,b[0]=(c[6]+c[2])*d,b[1]=(c[5]+c[7])*d,b[3]=(c[1]-c[3])*d);return this},toMatrix4:function(a){a||(a=new Matrix4);var b=this.data,c=a.data,d=b[0],e=b[1],f=b[2],g=b[3],h=d+d,i=e+e,j=f+f,k=d*h,l=d*i,m=d*j,n=e*i,o=e*j,p=f*j,q=g*h,r=g*i,s=g*j;c[0]=1-(n+p),c[1]=l+s,c[2]=m-r,c[3]=0,c[4]=l-s,c[5]=1-(k+p),c[6]=o+q,c[7]=0,c[8]=m+r,c[9]=o-q,c[10]=1-(k+n),c[11]=0,c[12]=0,c[13]=0,c[14]=0,c[15]=1;return a},dot:function(a){return this.data[0]*a.data[0]+this.data[1]*a.data[1]+this.data[2]*a.data[2]+this.data[3]*a.data[3]},slerp:function(a,b){if(this.data[0]==a.data[0]&&this.data[1]==a.data[1]&&this.data[2]==a.data[2]&&this.data[3]==a.data[3])return this;var c=this.dot(a);c<0&&(a=new Quaternion([-a.data[0],-a.data[1],-a.data[2],-a.data[3]]),c=-c);if(1-c<.001)return this;var d=1-b,e=b;if(1-c>.1){var f=Math.acos(c),g=1/Math.sin(f);d=Math.sin((1-b)*f)*g,e=Math.sin(b*f)*g}this.data[0]=d*this.data[0]+e*a.data[0],this.data[1]=d*this.data[1]+e*a.data[1],this.data[2]=d*this.data[2]+e*a.data[2],this.data[3]=d*this.data[3]+e*a.data[3];return this},clone:function(){return new Quaternion(this)},get x(){return this.data[0]},set x(a){this.data[0]=a},get y(){return this.data[1]},set y(a){this.data[1]=a},get z(){return this.data[2]},set z(a){this.data[2]=a},get w(){return this.data[3]},set w(a){this.data[3]=a},toString:function(){return"["+[this.data[0],this.data[1],this.data[2],this.data[3]]+"]"}},Transform.prototype={constructor:Transform,set:function(a){this.position.set(a.position),this.orientation.set(a.orientation),this.scale=a.scale;return this._invalidate()},setPosition:function(a){this.position.set(a);return this._invalidate()},setOrientation:function(a){this.orientation.set(a);return this._invalidate()},setScale:function(a){this.scale=a;return this._invalidate()},getPosition:function(a){a||(a=new Vector3);return a.set(this.position)},getOrientation:function(a){a||(a=new Quaternion);return a.set(this.orientation)},getScale:function(){return this.scale},setIdentity:function(){this.position.data.set([0,0,0]),this.orientation.data.set([0,0,0,1]),this.scale=1;return this._invalidate()},combineWith:function(a){TempVars.lock(),this.scale*=a.scale,a.orientation.multiplyVector3(this.position).scale(a.scale).add(a.position),this.orientation.preMultiply(a.orientation),TempVars.release();return this._invalidate()},getMatrix:function(a){a||(a=new Matrix4),this._needsUpdate&&this._update();return a.set(this.matrix)},setMatrix:function(a){var b=a.data,c=b[0],d=b[1],e=b[2];this.scale=Math.sqrt(c*c+d*d+e*e);var f=this.position.data;f[0]=b[12],f[1]=b[13],f[2]=b[14],TempVars.lock();var g=TempVars.getMatrix4().set(b);this.orientation.fromMatrix3(g.getRotationMatrix(TempVars.getMatrix3())),TempVars.release();return this._invalidate()},getInverseMatrix:function(a){a||(a=new Matrix4),this._needsUpdate&&this._update(),this.orientation.toMatrix4(a).transpose();var b=this.position.data,c=a.data,d=-b[0],e=-b[1],f=-b[2];c[12]=d*c[0]+e*c[4]+f*c[8],c[13]=d*c[1]+e*c[5]+f*c[9],c[14]=d*c[2]+e*c[6]+f*c[10];return a},_update:function(){var a=this.matrix,b=a.data;this.orientation.toMatrix4(a);if(this.scale!=1){var c=this.scale;b[0]*=c,b[1]*=c,b[2]*=c,b[4]*=c,b[5]*=c,b[6]*=c,b[8]*=c,b[9]*=c,b[10]*=c}var d=this.position.data;b[12]=d[0],b[13]=d[1],b[14]=d[2],this._needsUpdate=!1;return this},_invalidate:function(){this._needsUpdate=!0;return this}},Color.prototype={constructor:Color,clip:function(){var a=this.data;a[0]=a[0]>1?1:a[0]<0?0:a[0],a[1]=a[1]>1?1:a[1]<0?0:a[1],a[2]=a[2]>1?1:a[2]<0?0:a[2];return this},add:function(a){this.Vector3_add(a);return this.clip()},fromHex:function(a){var b=parseInt(a[0]+a[1],16),c=parseInt(a[2]+a[3],16),d=parseInt(a[4]+a[5],16);return this.fromRGB(b,c,d)},fromRGB:function(a,b,c){var d=this.data;d[0]=a,d[1]=b,d[2]=c;return this.scale(1/255)},fromHSL:function(a,b,c){function e(a,b,c){var d;c<0?c+=1:c>1&&(c-=1),6*c<1?d=a+(b-a)*c*6:2*c<1?d=b:3*c<2?d=a+(b-a)*(2/3-c)*6:d=a;return d}var d=this.data,f,g,h,i,j,k;b===0?d[0]=d[1]=d[2]=c:(c<=.5?g=c*(b+1):g=c+b-c*b,f=c*2-g,h=a/(2*Math.PI),d[0]=e(f,g,h+1/3),d[1]=e(f,g,h),d[2]=e(f,g,h-1/3))}},Color.extend(Vector3);var Renderer=function(a,b,c){function f(a){var b=[];for(var c=0;c<a;c++)b[c]={previous:null,next:null,index:c,texture:{}};for(c=0;c<a;c++)b[c].previous=b[c-1]||null,b[c].next=b[c+1]||null;return{head:b[0],tail:b[a-1]}}this.decayTime=5e3,this.width=b||640,this.height=c||480,this.render=this.dummyRender,this.canvas=a||document.createElement("canvas"),this.canvas.width=this.width,this.canvas.height=this.height,setInterval(this.decay.bind(this),this.decayTime);var d=this.gl=this.canvas.getContext("experimental-webgl");if(this.gl===null)throw"Could not initialize WebGL";d.mineUniformMatrix2fv=function(a,b){this.uniformMatrix2fv(a,!1,b)}.bind(d),d.mineUniformMatrix3fv=function(a,b){this.uniformMatrix3fv(a,!1,b)}.bind(d),d.mineUniformMatrix4fv=function(a,b){this.uniformMatrix4fv(a,!1,b)}.bind(d),d.mineUniformSampler2D=function(a,b,c){assert(c instanceof Texture,"Tried to set a non-Texture object to a sampler2D uniform"),assert(c.type===Texture.IMAGE,"The Texture object is not of type IMAGE"),this.uniform1i(b,a.bindTexture(c))}.bind(d,this),d.mineUniformSamplerCube=function(a,b,c){assert(c instanceof Texture,"Tried to set a non-Texture object to a samplerCube uniform"),assert(c.type===Texture.CUBEMAP,"The Texture object is not of type CUBEMAP"),this.uniform1i(b,a.bindTexture(c))}.bind(d,this);var e=this.getParameter(Renderer.MAX_FRAGMENT_TEXTURE_UNITS),g=f(e);this.firstTexture2DPosition=g.head,this.lastTexture2DPosition=g.tail,g=f(e),this.firstTextureCubePosition=g.head,this.lastTextureCubePosition=g.tail,this.bufferObjects={},this.textureObjects={},this.programObjects={},this.framebufferObjects={},this.currentShader=null,this.boundedBuffer=null,this.boundedFrameBuffer=null,d.viewport(0,0,this.width,this.height),d.clearColor(0,0,0,1),d.clearDepth(1),d.enable(d.CULL_FACE),d.enable(d.DEPTH_TEST),d.depthFunc(d.LEQUAL),d.disable(d.BLEND),d.clear(d.COLOR_BUFFER_BIT|d.DEPTH_BUFFER_BIT)};Renderer.MAX_FRAGMENT_TEXTURE_UNITS=1,Renderer.MAX_VERTEX_TEXTURE_UNITS=2,Renderer.FLOAT_TEXTURE=3,Renderer.prototype={constructor:Renderer,getParameter:function(a){switch(a){case Renderer.MAX_FRAGMENT_TEXTURE_UNITS:return this.gl.getParameter(this.gl.MAX_TEXTURE_IMAGE_UNITS);case Renderer.MAX_VERTEX_TEXTURE_UNITS:return this.gl.getParameter(this.gl.MAX_VERTEX_TEXTURE_IMAGE_UNITS);case Renderer.FLOAT_TEXTURE:var b=this.gl.getSupportedExtensions();for(var c=0;c<b.length;c++)if(b[c]=="OES_texture_float"){this.gl.getExtension(b[c]);return!0}return!1}},decayArray:function(a,b){var c=this.gl;for(var d in a){var e=a[d];e.used?e.used=!1:(b.call(c,e),delete a[d])}},decay:function(){var a=this.gl;this.decayArray(this.bufferObjects,a.deleteBuffer),this.decayArray(this.textureObjects,a.deleteTexture),this.decayArray(this.programObjects,a.deleteProgram)},createBuffer:function(a){assert(a instanceof Buffer,"Illegal type. buffer must be a Buffer object.");var b,c;switch(a.type){case Buffer.ELEMENT_BUFFER:b=this.gl.ELEMENT_ARRAY_BUFFER;break;case Buffer.DATA_BUFFER:b=this.gl.ARRAY_BUFFER}switch(a.usage){case Buffer.DYNAMIC:c=this.gl.DYNAMIC_DRAW;break;case Buffer.STREAM:c=this.gl.STREAM_DRAW;break;case Buffer.STATIC:c=this.gl.STATIC_DRAW}var d=this.gl.createBuffer();this.gl.bindBuffer(b,d),this.gl.bufferData(b,a.data,c),this.gl.bindBuffer(b,null),d.length=a.data.length,this.bufferObjects[a.uid]=d},deleteBuffer:function(a){assert(this.gl.isBuffer(this.bufferObjects[a]),"Illegal type. buffer must be a GL Buffer object."),this.gl.deleteBuffer(this.bufferObjects[a.uid]),delete this.bufferObjects[a.uid]},updateBuffer:function(a){assert(a instanceof Buffer,"Illegal type. buffer must be a Buffer object.");var b=this.bufferObjects[a.uid];if(typeof b=="undefined")this.createBuffer(a);else if(b.length!=a.data.length)this.deleteBuffer(a),this.createBuffer(a);else{var c;switch(a.type){case Buffer.DATA_BUFFER:c=this.gl.ARRAY_BUFFER;break;case Buffer.ELEMENT_BUFFER:c=this.gl.ELEMENT_BUFFER}this.gl.bindBuffer(c,this.bufferObjects[a.uid]),this.gl.bufferSubData(c,0,a.data),this.gl.bindBuffer(c,null)}a.needsUpdate=!1},isBuffer:function(a){try{return this.gl.isBuffer(a)}catch(b){return!1}},bindBuffer:function(a){assert(a instanceof Buffer,"Illegal type. buffer must be a Buffer object.");if(a.data!==null){var b,c;switch(a.type){case Buffer.DATA_BUFFER:c=this.gl.ARRAY_BUFFER;break;case Buffer.ELEMENT_BUFFER:c=this.gl.ELEMENT_ARRAY_BUFFER}if(!this.bufferObjects[a.uid]||a.needsUpdate
)this.updateBuffer(a),this.boundedBuffer=null;if(this.boundedBuffer==a)return;this.boundedBuffer=a,b=this.bufferObjects[a.uid],this.gl.bindBuffer(c,b),b.used=!0}},createTexture:function(a){assert(a instanceof Texture,"Invalid type. texture must be a Texture instance");if(!a.width.isPowerOfTwo()||!a.height.isPowerOfTwo())assert(a.minFilter!==Texture.NEAREST_MIPMAP_NEAREST,"Cannot use mipmapping with non power of two dimentions texture"),assert(a.minFilter!==Texture.NEAREST_MIPMAP_LINEAR,"Cannot use mipmapping with non power of two dimentions texture"),assert(a.minFilter!==Texture.LINEAR_MIPMAP_NEAREST,"Cannot use mipmapping with non power of two dimentions texture"),assert(a.minFilter!==Texture.LINEAR_MIPMAP_LINEAR,"Cannot use mipmapping with non power of two dimentions texture");var b=this.gl,c,d,e,f,g=b.createTexture();g.bindPosition=null,g.width=a.width,g.height=a.height;switch(a.origin){case Texture.UPPER_LEFT_CORNER:b.pixelStorei(b.UNPACK_FLIP_Y_WEBGL,!0);break;case Texture.LOWER_LEFT_CORNER:b.pixelStorei(b.UNPACK_FLIP_Y_WEBGL,!1)}switch(a.dataType){case Texture.UNSIGNED_BYTE:e=b.UNSIGNED_BYTE;break;case Texture.FLOAT:e=b.FLOAT}switch(a.format){case Texture.RGB:d=b.RGB;break;case Texture.RGBA:d=b.RGBA}switch(a.type){case Texture.IMAGE:c=b.TEXTURE_2D,f=b.getParameter(b.TEXTURE_BINDING_2D),b.bindTexture(c,g),a.source===null?b.texImage2D(c,0,d,a.width,a.height,0,d,e,null):b.texImage2D(c,0,d,d,e,a.source);break;case Texture.CUBEMAP:c=b.TEXTURE_CUBE_MAP,f=b.getParameter(b.TEXTURE_BINDING_CUBE_MAP),b.bindTexture(c,g);for(var h=0;h<6;++h)b.texImage2D(b.TEXTURE_CUBE_MAP_POSITIVE_X+h,0,d,d,e,a.source[h])}switch(a.minFilter){case Texture.NEAREST:b.texParameteri(c,b.TEXTURE_MIN_FILTER,b.NEAREST);break;case Texture.LINEAR:b.texParameteri(c,b.TEXTURE_MIN_FILTER,b.LINEAR);break;case Texture.NEAREST_MIPMAP_NEAREST:b.texParameteri(c,b.TEXTURE_MIN_FILTER,b.NEAREST_MIPMAP_NEAREST),b.generateMipmap(c);break;case Texture.NEAREST_MIPMAP_LINEAR:b.texParameteri(c,b.TEXTURE_MIN_FILTER,b.NEAREST_MIPMAP_LINEAR),b.generateMipmap(c);break;case Texture.LINEAR_MIPMAP_NEAREST:b.texParameteri(c,b.TEXTURE_MIN_FILTER,b.LINEAR_MIPMAP_NEAREST),b.generateMipmap(c);break;case Texture.LINEAR_MIPMAP_LINEAR:b.texParameteri(c,b.TEXTURE_MIN_FILTER,b.LINEAR_MIPMAP_LINEAR),b.generateMipmap(c)}switch(a.magFilter){case Texture.NEAREST:b.texParameteri(c,b.TEXTURE_MAG_FILTER,b.NEAREST);break;case Texture.LINEAR:b.texParameteri(c,b.TEXTURE_MAG_FILTER,b.LINEAR)}switch(a.wrapS){case Texture.REPEAT:b.texParameteri(c,b.TEXTURE_WRAP_S,b.REPEAT);break;case Texture.MIRROR_REPEAT:b.texParameteri(c,b.TEXTURE_WRAP_S,b.MIRRORED_REPEAT);break;case Texture.CLAMP_TO_EDGE:b.texParameteri(c,b.TEXTURE_WRAP_S,b.CLAMP_TO_EDGE)}switch(a.wrapT){case Texture.REPEAT:b.texParameteri(c,b.TEXTURE_WRAP_T,b.REPEAT);break;case Texture.MIRROR_REPEAT:b.texParameteri(c,b.TEXTURE_WRAP_T,b.MIRROR_REPEAT);break;case Texture.CLAMP_TO_EDGE:b.texParameteri(c,b.TEXTURE_WRAP_T,b.CLAMP_TO_EDGE)}b.bindTexture(c,f),this.textureObjects[a.uid]=g,a.needsUpdate=!1},updateTexture:function(a){assert(a instanceof Texture,"Invalid type. texture must be a Texture instance");if(typeof this.textureObjects[a.uid]=="undefined")this.createTexture(a);else{var b=this.textureObjects[a.uid];b.bindPosition&&(b.bindPosition.texture={},b.bindPosition=null);if(a.width!==b.width||a.height!==b.height){this.deleteTexture(a),this.createTexture(a);return}var c=this.gl,d;switch(a.type){case Texture.IMAGE:d=c.getParameter(c.TEXTURE_BINDING_2D),c.bindTexture(c.TEXTURE_2D,b),a.source===null?c.texImage2D(c.TEXTURE_2D,0,c.RGB,a.width,a.height,0,c.RGB,c.UNSIGNED_BYTE,null):c.texSubImage2D(c.TEXTURE_2D,0,0,0,c.RGB,c.UNSIGNED_BYTE,a.source),c.bindTexture(c.TEXTURE_2D,d);break;case Texture.CUBEMAP:throw"Not implemented"}a.needsUpdate=!1}},bindTexture:function(a){assert(a instanceof Texture,"Invalid type. texture must be a Texture instance");var b,c,d,e,f,g;(a.needsUpdate||typeof this.textureObjects[a.uid]=="undefined")&&this.updateTexture(a),d=this.gl,c=this.textureObjects[a.uid],c.used=!0,e=c.bindPosition;switch(a.type){case Texture.IMAGE:f=this.firstTexture2DPosition,e||(e=this.lastTexture2DPosition,e.texture.bindPosition=null,e.texture=c,c.bindPosition=e,d.activeTexture(d.TEXTURE0+e.index),d.bindTexture(d.TEXTURE_2D,c)),e.previous&&(e.next?e.next.previous=e.previous:this.lastTexture2DPosition=e.previous,e.previous.next=e.next,e.previous=null,e.next=f,f.previous=e,this.firstTexture2DPosition=e);break;case Texture.CUBEMAP:f=this.firstTextureCubePosition,e||(e=this.lastTextureCubePosition,e.texture.bindPosition=null,e.texture=c,c.bindPosition=e,d.activeTexture(d.TEXTURE0+e.index),d.bindTexture(d.TEXTURE_CUBE_MAP,c)),e.previous&&(e.next?e.next.previous=e.previous:this.lastTexture2DPosition=e.previous,e.previous.next=e.next,e.previous=null,e.next=f,f.previous=e,this.firstTexture2DPosition=e)}return e.index},deleteTexture:function(a){assert(a instanceof Texture,"Invalid type. texture must be a Texture instance");var b=this.textureObjects[a.uid];b&&(this.gl.deleteTexture(b),delete this.textureObjects[a.uid])},deleteFramebuffer:function(a){assert(a instanceof Framebuffer,"Invalid type. framebuffer must be a Framebuffer instance");var b=this.gl;this.deleteTexture(a.colorTexture);var c=this.framebufferObjects[a.uid];c&&(b.deleteRenderbuffer(c.renderbuffer),b.deleteFramebuffer(c))},createFramebuffer:function(a){assert(a instanceof Framebuffer,"Tried to update a non-framebuffer object");var b=this.gl,c=this.framebufferObjects[a.uid]=b.createFramebuffer();b.bindFramebuffer(b.FRAMEBUFFER,c),this.bindTexture(a.colorTexture),c.colorTexture=this.textureObjects[a.colorTexture.uid],b.framebufferTexture2D(b.FRAMEBUFFER,b.COLOR_ATTACHMENT0,b.TEXTURE_2D,c.colorTexture,0);var d=c.renderbuffer=b.createRenderbuffer();b.bindRenderbuffer(b.RENDERBUFFER,d),b.renderbufferStorage(b.RENDERBUFFER,b.DEPTH_COMPONENT16,a.width,a.height),b.framebufferRenderbuffer(b.FRAMEBUFFER,b.DEPTH_ATTACHMENT,b.RENDERBUFFER,d),b.bindRenderbuffer(b.RENDERBUFFER,null),assert(b.checkFramebufferStatus(b.FRAMEBUFFER)===b.FRAMEBUFFER_COMPLETE,"Framebuffer was not constructed correctly"),b.bindFramebuffer(b.FRAMEBUFFER,null)},updateFramebuffer:function(a){assert(a instanceof Framebuffer,"Tried to update a non-framebuffer object"),this.framebufferObjects[a.uid]&&this.deleteFramebuffer(a),this.createFramebuffer(a),a.needsUpdate=!1},bindFramebuffer:function(a){assert(a instanceof Framebuffer||a===null,"Tried to bind a non-framebuffer object");var b=this.gl,c;if(a!==null){c=this.framebufferObjects[a.uid];if(a.needsUpdate||!c||!this.textureObjects[a.colorTexture.uid])this.updateFramebuffer(a),c=this.framebufferObjects[a.uid];c.colorTexture.used=!0}else c=null;this.boundedFramebuffer!=a&&(b.bindFramebuffer(b.FRAMEBUFFER,c),this.boundedFramebuffer=a)},deleteShader:function(a){var b,c;c=this.gl,b=this.programObjects[a.uid],this.currentShader==a&&(this.currentShader=null),b&&(c.deleteShader(b.vertexShader),c.deleteShader(b.fragmentShader),c.deleteProgram(b),delete this.programObjects[a.uid])},createShader:function(a){var b,c,d,e,f,g,h,i;b=this.gl,h=b.createShader(b.VERTEX_SHADER),b.shaderSource(h,a.vertexSource),b.compileShader(h);if(!b.getShaderParameter(h,b.COMPILE_STATUS))throw"Vertex Shader compile error: "+b.getShaderInfoLog(h);i=b.createShader(b.FRAGMENT_SHADER),b.shaderSource(i,a.fragmentSource),b.compileShader(i);if(!b.getShaderParameter(i,b.COMPILE_STATUS))throw"Fragment Shader compile error: "+b.getShaderInfoLog(i);c=b.createProgram(),b.attachShader(c,h),c.vertexShader=h,b.attachShader(c,i),c.fragmentShader=i,b.linkProgram(c);if(!b.getProgramParameter(c,b.LINK_STATUS))throw"Program linking error: "+b.getProgramInfoLog(c);d=b.getProgramParameter(c,b.ACTIVE_UNIFORMS),c.uniforms={};while(d--){g=b.getActiveUniform(c,d);var j=g.size>1?g.name.slice(0,-3):g.name;c.uniforms[j]={location:b.getUniformLocation(c,g.name),set:null};switch(g.type){case b.FLOAT:c.uniforms[j].set=b.uniform1f.bind(b);break;case b.FLOAT_VEC2:c.uniforms[j].set=b.uniform2fv.bind(b);break;case b.FLOAT_VEC3:c.uniforms[j].set=b.uniform3fv.bind(b);break;case b.FLOAT_VEC4:c.uniforms[j].set=b.uniform4fv.bind(b);break;case b.INT:case b.BOOL:c.uniforms[j].set=b.uniform1i.bind(b);break;case b.INT_VEC2:case b.BOOL_VEC2:c.uniforms[j].set=b.uniform2iv.bind(b);break;case b.INT_VEC3:case b.BOOL_VEC3:c.uniforms[j].set=b.uniform3iv.bind(b);break;case b.INT_VEC4:case b.BOOL_VEC4:c.uniforms[j].set=b.uniform4iv.bind(b);break;case b.FLOAT_MAT2:c.uniforms[j].set=b.mineUniformMatrix2fv;break;case b.FLOAT_MAT3:c.uniforms[j].set=b.mineUniformMatrix3fv;break;case b.FLOAT_MAT4:c.uniforms[j].set=b.mineUniformMatrix4fv;break;case b.SAMPLER_2D:c.uniforms[j].set=b.mineUniformSampler2D;break;case b.SAMPLER_CUBE:c.uniforms[j].set=b.mineUniformSamplerCube}}e=b.getProgramParameter(c,b.ACTIVE_ATTRIBUTES),c.attributes={},b.useProgram(c);while(e--)b.enableVertexAttribArray(e),g=b.getActiveAttrib(c,e),c.attributes[g.name]={type:g.type,location:b.getAttribLocation(c,g.name)};b.useProgram(null),c.used=!0,this.programObjects[a.uid]=c,a.needsUpdate=!1},useShader:function(a){if(a===null)this.render=this.dummyRender;else{this.render=this._render;var b,c,d;if(!this.programObjects[a.uid]||a.needsUpdate)this.deleteShader(a),this.createShader(a),this.currentShader=null;b=this.programObjects[a.uid],this.currentShader!=a&&(this.gl.useProgram(b),this.currentShader=a),b.used=!0}},uploadShaderUniforms:function(){var a=this.currentShader;assert(a,"No shader to upload uniforms. Call useShader() before rendering anything");var b=this.programObjects[a.uid];for(var c in b.uniforms){assert(typeof a.uniforms[c]!="undefined",'Uniform "'+c+'" is undefined! You must set a value.');var d=b.uniforms[c];d.set(d.location,a.uniforms[c])}b.used=!0},setSize:function(a,b){this.canvas.width=this.width=a,this.canvas.height=this.height=b,this.gl.viewport(0,0,this.width,this.height)},clear:function(){this.gl.clear(this.gl.COLOR_BUFFER_BIT|this.gl.DEPTH_BUFFER_BIT)},_render:function(a){if(!this.currentShader)debug.log(debug.ERROR,"Tried to render without a shader. Call useShader() before rendering.");else{var b=this.gl,c;switch(a.mode){case Mesh.POINTS:c=b.POINTS;break;case Mesh.LINES:c=b.LINES;break;case Mesh.LINE_STRIP:c=b.LINE_STRIP;break;case Mesh.LINE_LOOP:c=b.LINE_LOOP;break;case Mesh.TRIANGLES:c=b.TRIANGLES;break;case Mesh.TRIANGLE_STRIP:c=b.TRIANGLE_STRIP}this.uploadShaderUniforms();var d=this.currentShader,e=this.programObjects[d.uid];for(var f in e.attributes){var g=a.vertexAttributes[f];assert(typeof g!="undefined",'VertexAttribute "'+f+'" is missing from the mesh.');switch(e.attributes[f].type){case b.FLOAT:assert(g.size===1,'VertexAttribute "'+f+'" needs a VertexAttribute of size = 1.');break;case b.FLOAT_VEC2:assert(g.size===2,'VertexAttribute "'+f+'" needs a VertexAttribute of size = 2.');break;case b.FLOAT_VEC3:assert(g.size===3,'VertexAttribute "'+f+'" needs a VertexAttribute of size = 3.');break;case b.FLOAT_VEC4:assert(g.size===4,'VertexAttribute "'+f+'" needs a VertexAttribute of size = 4.')}this.bindBuffer(g.buffer),b.vertexAttribPointer(e.attributes[f].location,g.size,b.FLOAT,!1,g.stride*4,g.offset*4)}this.bindBuffer(a.indexBuffer),b.drawElements(c,a.indexBuffer.data.length,b.UNSIGNED_SHORT,0)}},dummyRender:function(a){},render:null},Buffer.uid=0,Buffer.STATIC=1,Buffer.DYNAMIC=2,Buffer.STREAM=3,Buffer.DATA_BUFFER=4,Buffer.ELEMENT_BUFFER=5,Buffer.prototype={constructor:Buffer,setData:function(a){assertIn(a.constructor,Array,Float32Array,Uint16Array,"Invalid type. data must be an Array, Float32Array or Uint16Array");switch(this.type){case Buffer.ELEMENT_BUFFER:assertIn(a.constructor,Array,Uint16Array,"Invalid type. data must be an Array, Float32Array or Uint16Array");break;case Buffer.DATA_BUFFER:assertIn(a.constructor,Array,Float32Array,"Invalid type. data must be an Array, Float32Array or Uint16Array")}if(a.constructor==Array)switch(this.type){case Buffer.ELEMENT_BUFFER:this.data&&this.data.length==a.length?this.data.set(a):a=new Uint16Array(a);break;case Buffer.DATA_BUFFER:this.data&&this.data.length==a.length?this.data.set(a):a=new Float32Array(a)}this.needsUpdate=!0,this.data=a,this.length=a.length;return this},Uint16toUTF8:function(a){var b=a.length,c="",d;for(d=0;d<b;++d){var e=(a[d]+32)%65536;e==32?c+=String.fromCharCode(32,32):(e&63488)==55296?c+=String.fromCharCode(32,e-55255):c+=String.fromCharCode(e)}return c},UTF8toUint16:function(a){var b=a.length,c=[],d,e=new Uint16Array([0]);for(d=0;d<b;++d){var f=a.charCodeAt(d);if(f==32){var g=a.charCodeAt(++d);g>32&&(f=g+55255)}e[0]=f-32,c.push(e[0])}return new Uint16Array(c)},getExportData:function(a){var b={name:this.name,usage:this.usage,type:this.type,data:this.Uint16toUTF8(new Uint16Array(this.data.buffer))};return b},setImportData:function(a,b){this.name=b.name,this.usage=b.usage,this.type=b.type;switch(this.type){case Buffer.DATA_BUFFER:this.setData(new Float32Array(this.UTF8toUint16(b.data).buffer));break;case Buffer.ELEMENT_BUFFER:this.setData(this.UTF8toUint16(b.data))}return this}},VertexAttribute.prototype={constructor:VertexAttribute,getElement:function(a,b){var c=this.size;b||(b=new Float32Array(c));var d=this.buffer.data,e=this.stride||this.size;for(var f=0;f<c;f++)b[f]=d[this.offset+a*e+f];return b},setSize:function(a){this.size=a|0;return this.updateLength()},setOffset:function(a){this.offset=a|0;return this.updateLength()},setStride:function(a){this.stride=a|0;return this.updateLength()},setBuffer:function(a){assert(a instanceof Buffer,"Invalid type. buffer must be an instance of Buffer"),this.buffer=a;return this.updateLength()},updateLength:function(){this.stride===0?this.length=(this.buffer.length-this.offset)/this.size:this.length=(this.buffer.length-this.offset)/this.stride;return this},clone:function(){var a=new VertexAttribute(this.semantic);a.stride=this.stride,a.size=this.size,a.offset=this.offset,a.buffer=this.buffer;return a},getExportData:function(a){var b={stride:this.stride,size:this.size,offset:this.offset,semantic:this.semantic,name:this.name,buffer:this.buffer.getExportData(a)};return b},setImportData:function(a,b){this.name=b.name,this.semantic=b.semantic,this.stride=b.stride,this.size=b.size,this.offset=b.offset,this.setBuffer((new Buffer).setImportData(a,b.buffer));return this}},Texture.uid=0,Texture.IMAGE=1,Texture.CUBEMAP=2,Texture.NEAREST=1,Texture.LINEAR=2,Texture.NEAREST_MIPMAP_NEAREST=3,Texture.LINEAR_MIPMAP_NEAREST=4,Texture.NEAREST_MIPMAP_LINEAR=5,Texture.LINEAR_MIPMAP_LINEAR=6,Texture.REPEAT=1,Texture.MIRROR_REPEAT=2,Texture.CLAMP_TO_EDGE=3,Texture.LOWER_LEFT_CORNER=1,Texture.UPPER_LEFT_CORNER=2,Texture.RGB=1,Texture.RGBA=2,Texture.UNSIGNED_BYTE=1,Texture.FLOAT=2,Texture.prototype={constructor:Texture,setName:function(a){this.name=a||"Texture #"+this.uid;return this},setMinFilter:function(a){assertIn(a,Texture.NEAREST,Texture.LINEAR,Texture.NEAREST_MIPMAP_NEAREST,Texture.NEAREST_MIPMAP_LINEAR,Texture.LINEAR_MIPMAP_NEAREST,Texture.LINEAR_MIPMAP_LINEAR,"Unsupported minification filtering. "+a),this.minFilter=a;return this},setMagFilter:function(a){assertIn(a,Texture.NEAREST,Texture.LINEAR,"Unsupported minification filtering. "+a),this.magFilter=a;return this},setWrapS:function(a){assertIn(a,Texture.REPEAT,Texture.MIRROR_REPEAT,Texture.CLAMP_TO_EDGE,"Unsupported wrapping. "+a),this.wrapS=a;return this},setWrapT:function(a){assertIn(a,Texture.REPEAT,Texture.MIRROR_REPEAT,Texture.CLAMP_TO_EDGE,"Unsupported wrapping. "+a),this.wrapT=a;return this},setFormat:function(a){assertIn(a,Texture.RGB,Texture.RGBA,"Unsupported format. "+a),this.format=a;return this},setDataType:function(a){assertIn(a,Texture.UNSIGNED_BYTE,Texture.FLOAT,"Unsupported format. "+a),this.dataType=a;return this},setImage:function(a){assertIn(a.constructor,Image,HTMLImageElement,HTMLCanvasElement,HTMLVideoElement,"Unsupported type of source");if(a.constructor!=HTMLImageElement&&a.constructor!=Image||!!a.complete){this.source=a,this.setDimentions(this.source.width,this.source.height),this.needsUpdate=!0;return this}a.addEventListener("load",this.setImage.bind(this,a));return this},setDimentions:function(a,b){this.width=a,this.height=b;return this},getExportData:function(a){return{width:this.width,height:this.height,minFilter:this.minFilter,maxFilter:this.maxFilter,type:this.type,wrapS:this.wrapS,wrapT:this.wrapT,origin:this.origin,source:this.source!==null?this.source.getAttribute("src"):null}},setImportData:function(a,b){this.width=b.width,this.height=b.height,this.minFilter=b.minFilter,this.maxFilter=b.maxFilter,this.type=b.type,this.wrapS=b.wrapS,this.wrapT=b.wrapT,this.origin=b.origin;var c=new Image;c.src=b.source,this.setImage(c);return this}},Mesh.prototype={constructor:Mesh,setVertexAttribute:function(a){this.vertexAttributes[a.semantic]=a;return this},setIndexBuffer:function(a){this.indexBuffer=a;return this},interleave:function(){var a,b,c,d,e,f,g,h,i=0;for(d in this.vertexAttributes)e=this.vertexAttributes[d],i||(i=e.length),assert(e.length==i,"The vertex attributes in this mesh are of unequal lengths");a=new Buffer,c=0;for(d in this.vertexAttributes)c+=e.size,g=e.length;b=new Float32Array(g*c);var j=0;for(d in this.vertexAttributes){e=this.vertexAttributes[d],f=g;while(f--)h=c*f+j,e.getElement(f,b.subarray(h,h+e.size));e.stride=c,e.offset=j,j+=e.size,e.setBuffer(a)}a.setData(b);return this},setMode:function(a){assertIn(a,Mesh.POINTS,Mesh.LINES,Mesh.LINE_LOOP,Mesh.LINE_STRIP,Mesh.TRIANGLES,Mesh.TRIANGLE_STRIP,Mesh.TRIANGLE_FAN,"Illegal value."),this.mode=a;return this},calculateNormals:function(){var a=this.vertexAttributes.Position,b=this.indexBuffer.data,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t=[];for(r=0;r<a.length;++r)t[r]=[];TempVars.lock();var u=TempVars.getVector3(),v=TempVars.getVector3(),w=TempVars.getVector3();for(var x=0;x<b.length/3;++x)c=b[x*3+0],d=b[x*3+1],e=b[x*3+2],a.getElement(c,u),a.getElement(d,v),a.getElement(e,w),v.subtract(u),q=w.subtract(u).cross(v).normalize().clone(),t[c].push(q),t[d].push(q),t[e].push(q);TempVars.release();var y=[];for(r=0;r<t.length;++r){if(t[r].length===0){y.push(0,0,1);continue}if(t[r].length==1){y.push(t[r][0][0],t[r][0][1],t[r][0][2]);continue}for(s=1;s<t[r].length;++s)t[r][0].add(t[r][s]);t[r][0].normalize(),y.push(t[r][0][0],t[r][0][1],t[r][0][2])}t=(new Buffer).setData(y),t=(new VertexAttribute("Normal")).setBuffer(t),this.setVertexAttribute(t);return this},getExportData:function(a){var b={mode:this.mode,indexBuffer:this.indexBuffer.getExportData(a),vertexAttributes:{}};for(var c in this.vertexAttributes)b.vertexAttributes[c]=this.vertexAttributes[c].getExportData(a);return b},setImportData:function(a,b){this.mode=b.mode,this.indexBuffer=(new Buffer).setImportData(a,b.indexBuffer);for(var c in b.vertexAttributes)this.vertexAttributes[c]=(new VertexAttribute).setImportData(a,b.vertexAttributes[c]);return this}},Mesh.POINTS=1,Mesh.LINES=2,Mesh.LINE_LOOP=3,Mesh.LINE_STRIP=4,Mesh.TRIANGLES=5,Mesh.TRIANGLE_STRIP=6,Mesh.TRIANGLE_FAN=7,Shader.uid=0,Shader.prototype={constructor:Shader,setVertexSource:function(a){this.vertexSource=a,this.needsUpdate=!0},setFragmentSource:function(a){this.fragmentSource=a,this.needsUpdate=!0},getExportData:function(a){return{vertexSource:this.vertexSource.split("\n"),fragmentSource:this.fragmentSource.split("\n"),name:this.name}},setImportData:function(a,b){this.vertexSource=b.vertexSource.join("\n"),this.fragmentSource=b.fragmentSource.join("\n"),this.name=b.name,this.needsUpdate=!0;return this}},Framebuffer.uid=0,Framebuffer.prototype={constructor:Framebuffer,setColorTexture:function(a){assert(a instanceof Texture,"texture must be an instance of Texture"),this.colorTexture=a;return this},setDimentions:function(a,b){if(a!==this.width||b!==this.height)this.needsUpdate=!0,this.width=a,this.height=b,this.colorTexture.setDimentions(this.width,this.height);return this}},BoundingSphere.prototype={constructor:BoundingSphere,calculateFromVertices:function(a){TempVars.lock();var b=TempVars.getVector3(),c=0,d,e=a.length;while(e--)d=a.getElement(e,b).length2(),d>c&&(c=d);this.radius=Math.sqrt(c),TempVars.release();return this}},BoundingBox.prototype={constructor:BoundingBox,calculateFromVertices:function(a){TempVars.lock();var b=TempVars.getVector3(),c=this.halfExtent,d=a.length;while(d--)a.getElement(d,b).absolute(),b[0]<c[0]&&(c[0]=b[0]),b[1]<c[1]&&(c[1]=b[1]),b[2]<c[2]&&(c[2]=b[2]);return this}},SceneNode.prototype={constructor:SceneNode,getAbsolutePosition:function(a){a||(a=new Vector3),this._update();return a.set(this.worldTransform.position)},setAbsolutePosition:function(a){TempVars.lock(),this.worldTransform.setPosition(a),a=TempVars.getVector3().set(a);var b=this.parent,c=b.getAbsoluteOrientation(TempVars.getQuaternion()),d=b.getAbsolutePosition(TempVars.getVector3()),e=b.getAbsoluteScale();this.position.set(c.inverse().multiplyVector3(a.subtract(d))),e!=1&&this.position.scale(1/e),TempVars.release();return this._invalidate()},getAbsoluteOrientation:function(a){a||(a=new Quaternion),this._update();return this.worldTransform.getOrientation(a)},setAbsoluteOrientation:function(a){TempVars.lock(),this.worldTransform.setOrientation(a),this.orientation.set(this.parent.getAbsoluteOrientation(TempVars.getQuaternion()).inverse().preMultiply(a)),TempVars.release();return this._invalidate()},getAbsoluteScale:function(){this._update();return this.worldTransform.getScale()},setAbsoluteScale:function(a){this.worldTransform.setScale(a),this.scale=a/this.parent.getAbsoluteScale();return this._invalidate()},rotate:function(a,b,c){TempVars.lock(),b-=2*Math.PI*Math.floor(b/2/Math.PI);var d=TempVars.getQuaternion().setAxisAngle(a,b);if(c){var e=this.getAbsolutePosition(TempVars.getVector3());if(c===SceneNode.Origin)d.multiplyVector3(e);else{var f=c.getAbsolutePosition(TempVars.getVector3()),g=c.getAbsoluteOrientation(TempVars.getQuaternion());g.inverse().multiplyVector3(e.subtract(f)),d.multiplyVector3(e),g.inverse().multiplyVector3(e).add(f)}this.setAbsolutePosition(e)}this.orientation.preMultiply(d),TempVars.release();return this._invalidate()},move:function(a,b){if(b){if(b==SceneNode.Origin){TempVars.lock();var c=this.getAbsolutePosition(TempVars.getVector3()).add(a);this.setAbsolutePosition(c),TempVars.release();return this}throw"Not yet implemented"}this.position.add(a);return this._invalidate()},appendChild:function(a){a.parent!==SceneNode.Origin&&a.parent.removeChild(a),a.parent=this,this.children.push(a),a._invalidate(),this.onChildAdded(a);return this},onChildAdded:function(a){this.emit("childadded",a),this!==SceneNode.Origin&&this.parent.onChildAdded(a)},removeChild:function(a){var b=this.children,c=b.length;a.parent=SceneNode.Origin,a._invalidate(),b.splice(b.indexOf(a),1),this.onChildRemoved(a);return this},onChildRemoved:function(a){this.emit("childremoved",a),this!==SceneNode.Origin&&this.parent.onChildRemoved(a)},getAbsoluteMatrix:function(a){a||(a=new Matrix4),this._update();return a.set(this.worldTransform.getMatrix())},getAbsoluteInverseMatrix:function(a){a||(a=new Matrix4),this._update();return a.set(this.worldTransform.getInverseMatrix())},_update:function(){if(this._needsUpdate){this.Transform__update();var a=this.parent;a._update(),this.worldTransform.set(this).combineWith(a.worldTransform)}return this},_invalidate:function(){this.Transform__invalidate();var a=this.children.length;while(a--)this.children[a]._invalidate();return this},getExportData:function(a){var b={};b.position=this.getPosition()+"",b.orientation=this.getOrientation()+"",b.scale=this.getScale(),b.name=this.name,b.children=[];var c=this.children.length;while(c--){var d=this.children[c];b.children.push(d.name),a.alsoSave(d)}return b},setImportData:function(a,b){this.name=b.name,this.setPosition(new Vector3(b.position)),this.setOrientation(new Quaternion(b.orientation)),this.setScale(b.scale);var c=b.children.length;while(c--)a.load(b.children[c],this.appendChild.bind(this))}},SceneNode.extend(Transform),SceneNode.extend(EventEmitter),SceneNode.Origin=new SceneNode,SceneNode.Origin.parent=SceneNode.Origin,Camera.prototype={constructor:Camera,setPerspective:function(){Matrix4.perspective(this.fieldOfView,this.width/this.height,this.zNear,this.zFar,this.projectionMatrix),this.ratio=this.width/this.height,this.horizontalCosFielfOfView=Math.cos(Math.atan(this.tanFieldOfView*this.ratio)),this.horizontalTanFieldOfView=this.tanFieldOfView*this.ratio}},Camera.extend(SceneNode),Drawable.prototype={constructor:Drawable,onBeforeRender:function(a){},setMaterial:function(a){assert(Material.prototype.isPrototypeOf(a),"Tried to set a material which is not or does not inherit from Material"),this.material=a;return this},getExportData:function(a){var b={};b.parent=this.SceneNode_getExportData(a),b.mesh=this.mesh.name,b.material=this.material.name,a.alsoSave(this.mesh),a.alsoSave(this.material);return b},setImportData:function(a,b){this.SceneNode_setImportData(a,b.parent);var c=this;a.load(b.mesh,function(a){c.mesh=a}),a.load(b.material,function(a){c.material=a})}},Drawable.extend(SceneNode),Light.extend(SceneNode),Scene.prototype={constructor:Scene,findClass:function(a,b){var c=[],d=0,e=[a],f=1,g,h;while(f){a=e[--f],a instanceof b&&(c[d++]=a),g=a.children,h=g.length;while(h--)e[f++]=g[h]}return c},onChildAdded:function(a){this.SceneNode_onChildAdded(a);var b=this.findClass(a,Drawable);this.drawableList.push.apply(this.drawableList,b)},onChildRemoved:function(a){this.SceneNode_onChildRemoved(a);var b=this.findClass(a,Drawable),c=b.length;while(c--)this.drawableList.splice(this.drawableList.indexOf(b[c]),1)}},Scene.extend(SceneNode),Material.uid=0,Material.prototype={constructor:Material,setParameter:function(a,b){typeof b=="object"?this.parameters[a]=b.data:this.parameters[a]=b;return this},getShader:function(){if(this.shader!==null)for(var a in this.parameters)this.shader.uniforms[a]=this.parameters[a];return this.shader}},BasicMaterial.extend(Material),TexturedMaterial.extend(Material),Cube.extend(Drawable),Rectangle.extend(Drawable),Sphere.extend(Drawable),InputDevice.prototype.addAction=function(a,b){},Keyboard.prototype={getKeyData:function(a){this.keyData[a]||(this.keyData[a]={});return this.keyData[a]},setPressed:function(a){if(!this.pressed[a]){var b;for(var c in this.pressed){if(c==a)continue;b=this.getKeyData(c),clearInterval(b.upInterval),b.upInterval=0}this.pressed[a]=!0}},unsetPressed:function(a){!this.pressed[a]||delete this.pressed[a]},handleKeyDown:function(a){var b=this,c=this.actions[a.keyCode],d;if(!!c&&!!c.length){d=this.getKeyData(a.keyCode),d.lastPress=Date.now();if(this.pressed[a.keyCode])return;var e=!1;c.forEach(function(b){b.callback(a),b.endCallback&&(e=!0),b.repeat&&(b.repeatInterval=setInterval(b.callback,b.speed))}),this.setPressed(a.keyCode)}},handleKeyUp:function(a){var b=this.actions[a.keyCode],c=this.getKeyData(a.keyCode);!b||(c.upInterval&&clearInterval(c.upInterval),b.forEach(function(b){b.endCallback&&b.endCallback(a),b.repeatInterval&&(clearInterval(b.repeatInterval),b.repeatInterval=!1)}),clearInterval(c.upInterval),c.upInterval=0,clearTimeout(c.upCallback),c.upCallback=0,this.unsetPressed(a.keyCode))},addAction:function(a,b){typeof b=="function"&&(b={callback:b});var c={callback:b.callback||function(){},endCallback:b.endCallback||null,repeat:b.repeat,speed:b.speed||10};this.actions[a]?this.actions[a].push(c):this.actions[a]=[c]},handleMouseOut:function(a){var b=a.relatedTarget||a.toElement;if(!b||b.nodeName=="HTML")for(var c in this.pressed)this.handleKeyUp({keyCode:c})},checkAutoRepeat:function(a){var b=this.getKeyData(a.keyCode),c=this;!this.pressed[a.keyCode]||(b.upInterval=setInterval(function(){Date.now()-b.lastPress<c.REPEAT_INTERVAL||c.handleKeyUp(a)},100))}},Keyboard.extend(InputDevice),Keyboard.KEY_LEFT_ARROW=37,Keyboard.KEY_UP_ARROW=38,Keyboard.KEY_RIGHT_ARROW=39,Keyboard.KEY_DOWN_ARROW=40,Keyboard.KEY_SPACE=32,Keyboard.KEY_ENTER=13,Keyboard.KEY_ESCAPE=27,Keyboard.KEY_A=65,Keyboard.KEY_B=66,Keyboard.KEY_C=67,Keyboard.KEY_D=68,Keyboard.KEY_E=69,Keyboard.KEY_F=70,Keyboard.KEY_G=71,Keyboard.KEY_H=72,Keyboard.KEY_I=73,Keyboard.KEY_J=74,Keyboard.KEY_K=75,Keyboard.KEY_L=76,Keyboard.KEY_M=77,Keyboard.KEY_N=78,Keyboard.KEY_O=79,Keyboard.KEY_P=80,Keyboard.KEY_Q=81,Keyboard.KEY_R=82,Keyboard.KEY_S=83,Keyboard.KEY_T=84,Keyboard.KEY_U=85,Keyboard.KEY_V=86,Keyboard.KEY_W=87,Keyboard.KEY_X=88,Keyboard.KEY_Y=89,Keyboard.KEY_Z=90,Mouse.prototype={constructor:Mouse,handleMouseDown:function(a){var b,c,d=this.actions[a.button],e;this.down[a.button]=!0;if(!!d){this.addCustomEventData(a),e=d.length;for(b=0;b<e;++b)d[b].callback(a)}},handleMouseUp:function(a){var b,c,d=this.actions[a.button],e;this.down[a.button]=!1;if(!!d){this.addCustomEventData(a),e=d.length;for(b=0;b<e;++b)d[b].endCallback(a)}},handleMouseMove:function(a){var b,c,d=this.actions[Mouse.MOUSE_MOVE],e;this.addCustomEventData(a),this.prevX=a.screenX,this.prevY=a.screenY;if(!!d){e=d.length;for(b=0;b<e;++b)d[b].callback(a)}},handleMouseWheel:function(a){var b,c,d=this.actions[Mouse.MOUSE_WHEEL],e;if(!!d){a.detail&&(a.wheelDelta=-a.detail/3),this.addCustomEventData(a),e=d.length;for(b=0;b<e;++b)d[b].callback(a)}},addAction:function(a,b){typeof b=="function"&&(b={callback:b}),this.actions[a]?this.actions[a].push(b):this.actions[a]=[b]},addCustomEventData:function(a){a.leftButton=!!this.down[Mouse.BUTTON_LEFT],a.middleButton=!!this.down[Mouse.BUTTON_MIDDLE],a.rightButton=!!this.down[Mouse.BUTTON_RIGHT],a.xDelta=a.screenX-this.prevX,a.yDelta=a.screenY-this.prevY}},Mouse.BUTTON_LEFT=0,Mouse.BUTTON_MIDDLE=1,Mouse.BUTTON_RIGHT=2,Mouse.MOUSE_WHEEL=3,Mouse.MOUSE_MOVE=4,InputHandler.prototype.enable=function(){var a,b=this.actions.length;for(a=0;a<b;++a)this.actions[a].enable();this.enabled=!0},InputHandler.prototype.disable=function(){var a,b=this.actions.length;for(a=0;a<b;++a)this.actions[a].disable();this.enabled=!1},InputHandler.prototype.isEnabled=function(){return this.enabled},InputHandler.prototype.addAction=function(a,b,c){var d=this,e=c.callback||function(){};c.callback=function(a){d.enabled&&e(a)},this.actions.push(c),a.addAction(b,c);return c},InputHandler.prototype.onKey=function(a,b){typeof b!="object"&&(b={callback:b});{if(!Array.isArray(a))return this.addAction(this.keyboard,Keyboard["KEY_"+a],b);for(var c in a){var d={};for(var e in b)d[e]=b[e];this.onKey(a[c],d)}}},InputHandler.prototype.onKeyUp=function(a,b){typeof b!="object"&&(b={callback:function(){},endCallback:b});{if(!Array.isArray(a))return this.addAction(this.keyboard,Keyboard["KEY_"+a],b);for(var c in a){var d={};for(var e in b)d[e]=b[e];this.onKeyUp(a[c],d)}}},InputHandler.prototype.onMouseMove=function(a){this.addAction(this.mouse,Mouse.MOUSE_MOVE,a)},InputHandler.prototype.onMouseWheel=function(a){this.addAction(this.mouse,Mouse.MOUSE_WHEEL,a)},InputHandler.prototype.addDevice=function(a){if(this.devices.indexOf(a)!=-1)throw"Device name already in use";this.devices.push(a);return this},InputHandler.prototype.removeDevice=function(a){this.devices.splice(this.devices.indexOf(a),1);return this},UIComponent.prototype={attachCSS:function(a){var b=document.createElement("link");b.type="text/css",b.rel="stylesheet",b.href=a,document.head.appendChild(b)},loadHTML:function(a,b){var c=this;Request.get(a,{},function(a){var c=document.createElement("div");c.innerHTML=a,b(c)})}},RenderManager.prototype={constructor:RenderManager,addPostProcessEffect:function(a){this.postProcess=!0,this.postProcessEffects.push(a);return this},applyPostProcessEffects:function(){var a,b,c,d=this.postProcessEffects,e=this.quad,f=this.renderer,g=this.framebuffer.colorTexture;b=d.length,f.bindFramebuffer(null),f.clear();for(a=0;a<b;++a)c=d[a],c.setParameter("ColorTexture",g),c.setParameter("FramebufferWidth",this.framebuffer.width),c.setParameter("FramebufferHeight",this.framebuffer.height),f.useShader(c.getShader()),f.render(e);return this},resize:function(a,b){this.renderer.setSize(a,b),this.framebuffer.setDimentions(a,b);return this},renderScene:function(a,b){this.postProcess&&this.renderer.bindFramebuffer(this.framebuffer),this.renderer.clear();var c=this.globalUniformCache;b.projectionMatrix.copyTo(c.ProjectionMatrix),b.getAbsoluteInverseMatrix(c.ViewMatrix),c.ViewProjectionMatrix.set(c.ProjectionMatrix).multiply(c.ViewMatrix);var d=a.drawableList;d.sort(function(a,b){return a.material.uid-b.material.uid});var e=-1,f=d.length;while(f--){var g=d[f];g.onBeforeRender(b),g.getAbsoluteMatrix(c.WorldMatrix),c.WorldViewMatrix.set(c.ViewMatrix).multiply(c.WorldMatrix),c.WorldViewProjectionMatrix.set(c.ViewProjectionMatrix).multiply(c.WorldMatrix);var h=g.material;for(var i in h.engineParameters)h.setParameter(i,c[i]);this.renderer.useShader(h.getShader()),this.renderer.render(g.mesh)}this.postProcess&&this.applyPostProcessEffects()}},Exporter.prototype={save:function(a,b){this.isSaving=!0
;var c={library:{},object:a.name};c.library[a.name]={"class":a.constructor.name,data:a.getExportData(this)};var d=this,e=window.escape(JSON.stringify(c));Request.post("http://localhost:5000/",{data:e},function(){d.pending.length>0?d.save(d.pending.shift(),b):(d.isSaving=!1,b())})},alsoSave:function(a){this.isSaving?this.pending.push(a):this.save(a)}},Importer.prototype={constructor:Importer,load:function(a,b){var c=this,d;b||(b=this.defaultCallback),d=a.slice(a.lastIndexOf(".")+1).toLowerCase();if(typeof Importer.loader[d]=="undefined"||a.indexOf(".")==-1)d="json",a+=".json";a=this.resourcePath+a;Importer.cache[a]?b(Importer.cache[a],a):Importer.getLoader(d).load(a,this,function(c){Importer.cache[a]=c,b(c,a)})}},Importer.setLoader=function(a,b){a=a.toLowerCase(),typeof Importer.loader[a]!="undefined"&&console.log("Importer: overwriting loader for extension "+a),Importer.loader[a]=b},Importer.getLoader=function(a){return Importer.loader[a]},Importer.cache={},Importer.loader={},JSONLoader.prototype={constructor:JSONLoader,load:function(a,b,c){var d=this;Request.get(a,{},function(a){c(d.processData(a,b))})},processData:function(data,importer){data=JSON.parse(data);var object=data.library[data.object];if(/[a-zA-Z_$][0-9a-zA-Z_$]*/.test(object["class"])){var ObjectClass=eval(object["class"]);if(typeof ObjectClass=="function"){var ret=new ObjectClass;ret.setImportData(importer,object.data);return ret}}return null}},Importer.setLoader("json",new JSONLoader),OBJLoader.prototype={constructor:OBJLoader,loadMtl:function(a,b){var c=this;if(this.mtlCache[a]!==undefined&&!1)b(this.mtlCache[a]);else{var d=a.substring(0,a.lastIndexOf("/")+1),e=new XMLHttpRequest;e.open("GET",a),e.onreadystatechange=function(){if(e.readyState==4){var f={},g=e.responseText.split("\n"),h,i,j=g.length,k;for(h=0;h<j;h++){i=g[h].trim().split(/\s+/);switch(i[0]){case"newmtl":k=i[1],f[k]={};break;case"map_Kd":f[k].diffuseTexture=d+i[1];break;case"Ka":f[k].ambient=[i[1],i[2],i[3]];break;case"Kd":f[k].diffuse=[i[1],i[2],i[3]];break;case"Ks":f[k].specular=[i[1],i[2],i[3]];break;case"bump":f[k].bumpTexture=d+i[1]}}var l={};for(var m in f)if(f[m].diffuseTexture!==undefined){var n=f[m].diffuseTexture;f[m]=new TexturedMaterial,f[m].name=m;var o;if(l[n])o=l[n];else{var p=new Image;p.src=n,o=l[n]=(new Texture).setImage(p).setWrapS(Texture.REPEAT).setWrapT(Texture.REPEAT)}f[m].setParameter("texture",{data:o})}else{var q=f[m].diffuse;f[m]=new BasicMaterial,f[m].name=m,f[m].setParameter("Diffuse",new Vector3(q))}c.mtlCache[a]=f,b(f)}},e.send()}},load:function(a,b,c){if(!this.ready)this.pending.push(arguments);else{var d=c;c=function(a){var b=new SceneNode;for(var c in a){var e=new Drawable,f=a[c],g=new Buffer(Buffer.DATA_BUFFER,Buffer.STATIC);g.setData(f.vertices);var h=new Buffer(Buffer.DATA_BUFFER,Buffer.STATIC);h.setData(f.uvcoords);var i=new Buffer(Buffer.DATA_BUFFER,Buffer.STATIC);i.setData(f.normals);var j=new VertexAttribute("Position");j.setBuffer(g);var k=new VertexAttribute("Normal");k.setBuffer(i);var l=new VertexAttribute("UVCoord");l.size=2,l.setBuffer(h);var m=new Buffer(Buffer.ELEMENT_BUFFER,Buffer.STATIC);m.setData(f.indices);var n=new Mesh;n.setVertexAttribute(j),n.setVertexAttribute(k),n.setVertexAttribute(l),n.setIndexBuffer(m),e.mesh=n,e.setMaterial(f.material),n.name=c+"_mesh",e.name=c+"_drawable",b.appendChild(e)}d(b)};var e=this;if(this.objCache[a]!==undefined){c(this.objCache[a]);return}var f=a.substring(0,a.lastIndexOf("/")+1),g=new XMLHttpRequest;g.open("GET",a),g.onreadystatechange=function(){if(g.readyState==4){var b=g.responseText,d=b.split("\n"),h,i,j,k,l,m=[],n=[],o=[],p={},q=!0,r=function(b){for(var d in p){if(d==="default")continue;p[d].material=b[d]}e.objCache[a]=p,c(p)};p["default"]={vertices:[],normals:[],uvcoords:[],indices:[],material:"solid",indexIndex:0},k=p["default"];var s=d.length,t;for(h=0;h<s;++h){j=d[h].trim().split(/\s+/);switch(j[0]){case"mtllib":q=!1,e.loadMtl(f+j[1],r);break;case"usemtl":var u=j[1];p[u]===undefined&&(p[u]={vertices:[],normals:[],uvcoords:[],indices:[],uberObject:{},indexIndex:0}),k=p[u];break;case"v":m.push(j[1],j[2],j[3]);break;case"vn":n.push(j[1],j[2],j[3]);break;case"vt":o.push(j[1],j[2]);break;case"f":var v,w,x,y;for(i=1;i<=3;++i)y=j[i].split("/"),v=(y[0]-1)*3,w=(y[1]-1)*2,x=(y[2]-1)*3,t=k.uberObject[j[i]],t?k.indices.push(t):(k.vertices.push(m[v],m[v+1],m[v+2]),k.uvcoords.push(o[w],o[w+1]),k.normals.push(n[x],n[x+1],n[x+2]),k.indices.push(k.indexIndex),k.uberObject[j[i]]=k.indexIndex++);j[4]!==undefined&&(v=(j[3].split("/")[0]-1)*3,w=(j[3].split("/")[1]-1)*2,x=(j[3].split("/")[2]-1)*3,t=k.uberObject[j[3]],t?k.indices.push(t):(k.vertices.push(m[v],m[v+1],m[v+2]),k.uvcoords.push(o[w],o[w+1]),k.normals.push(n[x],n[x+1],n[x+2]),k.indices.push(k.indexIndex),k.uberObject[j[i]]=k.indexIndex++),v=(j[4].split("/")[0]-1)*3,w=(j[4].split("/")[1]-1)*2,x=(j[4].split("/")[2]-1)*3,t=k.uberObject[j[4]],t?k.indices.push(t):(k.vertices.push(m[v],m[v+1],m[v+2]),k.uvcoords.push(o[w],o[w+1]),k.normals.push(n[x],n[x+1],n[x+2]),k.indices.push(k.indexIndex),k.uberObject[j[i]]=k.indexIndex++),v=(j[1].split("/")[0]-1)*3,w=(j[1].split("/")[1]-1)*2,x=(j[1].split("/")[2]-1)*3,t=k.uberObject[j[1]],t?k.indices.push(t):(k.vertices.push(m[v],m[v+1],m[v+2]),k.uvcoords.push(o[w],o[w+1]),k.normals.push(n[x],n[x+1],n[x+2]),k.indices.push(k.indexIndex),k.uberObject[j[i]]=k.indexIndex++))}}for(h in p)p[h].indices.length===0&&delete p[h];q&&(e.objCache[a]=p,c(p))}},g.send()}}},Importer.setLoader("obj",new OBJLoader),SoundLoader.prototype={constructor:SoundLoader,load:function(a,b,c){var d=new XMLHttpRequest;d.open("GET",a,!0),d.responseType="arraybuffer",d.onload=function(){var a=new SoundAsset(d.response);c(a)},d.send()}},function(){var a=new SoundLoader;Importer.setLoader("mp3",a),Importer.setLoader("wav",a),Importer.setLoader("ogg",a)}(),SoundAsset.prototype={constructor:SoundAsset,getMetadata:function(a){var b=this;this.duration?a({duration:this.duration}):this.on("loadedmetadata",function(){a({duration:b.duration})})}},SoundAsset.extend(EventEmitter),SoundAsset.uid=0,SoundSource.LOOP_NONE=0,SoundSource.LOOP_ONE=1,SoundSource.LOOP_ALL=2,SoundSource.prototype={constructor:SoundSource,addSound:function(a){this.assets.push(a),this.emit("soundadded",a)},_play:function(a){var b=this;a.getMetadata(function(c){var d=c.duration/1e3;b.nowPlaying=a,b.emit("playing",a),setTimeout(function(){b.ended()},d)})},play:function(a){if(!(a instanceof SoundAsset))if(typeof a=="number"){if(this.currentTrack>this.assets.length){console.log("play: unknown track number "+a);return!1}this.currentTrack=a,a=this.assets[this.currentTrack]}else if(!a&&this.assets.length)this.currentTrack>=this.assets.length&&(this.currentTrack=0),a=this.assets[this.currentTrack];else{console.log("invalid parameter to play",a);return!1}this.playAll=!1,this._play(a)},playAll:function(a){a=a||0;a>=this.assets.length?console.log("playAll: unknown track number "+a):(this.currentTrack=a,this.loop==SoundSource.LOOP_ONE&&(this.loop=SoundSource.LOOP_NONE),this.playAll=!0,this._play(this.assets[this.currentTrack]))},setVelocity:function(a){this.velocity=a},getVelocity:function(){return this.velocity},ended:function(){this.emit("ended",this.nowPlaying),this.playAll&&(this.currentTrack=(this.currentTrack+1)%this.assets.length);switch(this.loop){case SoundSource.LOOP_NONE:this.nowPlaying=null;break;case SoundSource.LOOP_ONE:this.play(this.nowPlaying);break;case SoundSource.LOOP_ALL:this.currentTrack>0&&this._play(this.assets[this.currentTrack]);break;default:console.log("unknown soundsource loop property")}}},SoundSource.extend(SceneNode),SoundSource.uid=0,SoundManager.MAX_HEARING_DISTANCE=200,SoundManager.prototype={update:function(a){var b,c=this.camera.getAbsolutePosition().data;if(this.context){this.context.listener.setPosition(c[0],c[1],c[2]);for(b in this.playing)this.updatePanner(this.playing[b].source,this.playing[b].panner)}},addSource:function(a){function e(c){b.context&&a.parent!=b.camera?b.loadBufferData(c):c.tag.load()}function d(c){b.endAsset(a,c)}function c(c){assert(c instanceof SoundAsset,"Tried to play asset that is not instance of SoundAsset"),b.playAsset(a,c)}var b=this;assert(a instanceof SoundSource,"Tried to add source that is not instance of SoundSource"),a.on("playing",c),a.on("ended",d),a.on("soundadded",e),this.callbacks[a.uid]={onplaying:c,onended:d,onsoundadded:e}},removeSource:function(a){assert(a instanceof SoundSource,"Tried to remove source that is not instance of SoundSource"),assert(a.uid in this.callbacks,"Tried to remove source that was not added");var b,c=this.callbacks[a.uid];for(b in c)a.removeListener(b,c[b]);delete this.callbacks[a.uid],delete this.playing[a.uid]},playAsset:function(a,b){var c=this;this.context&&a.parent!=this.camera?this.bufferData[b.uid]?this.playFromAudioBuffer(a,b):this.loadBufferData(b,function(){c.playFromAudioBuffer(a,b)}):this.playFromAudioTag(a,b)},playFromAudioTag:function(a,b){var c=a.getAbsolutePosition().subtract(this.camera.getAbsolutePosition()),d=c.length(),e=(SoundManager.MAX_HEARING_DISTANCE-d)/SoundManager.MAX_HEARING_DISTANCE;b.tag.load(),b.tag.volume=e>0?e:0,b.tag.play()},playFromAudioBuffer:function(a,b){var c=this.context.createBufferSource(),d=this.context.createPanner(),e=this.context.createGainNode();c.buffer=this.context.createBuffer(this.bufferData[b.uid],!1),this.updatePanner(a,d),c.connect(d),d.connect(e),e.connect(this.compressor),c.loop=a.loop==SoundSource.LOOP_ONE,c.noteOn(0),this.playing[a.uid]={asset:b,source:a,bufferSource:c,start:this.context.currentTime,end:a.loop?Infinity:this.context.currentTime+c.buffer.duration,panner:d}},endAsset:function(a,b){this.playing[a.uid].bufferSource.noteOff(0),a.loop!=SoundSource.LOOP_ONE&&delete this.playing[a.uid]},updatePanner:function(a,b){var c=a.getAbsolutePosition().data,d=a.getVelocity().data;b.setPosition(c[0],c[1],c[2]),b.setVelocity(d[0],d[1],d[2])},loadBufferData:function(a,b){var c=this,d=new XMLHttpRequest;d.open("GET",a.url,!0),d.responseType="arraybuffer",d.onload=function(){c.bufferData[a.uid]=d.response,typeof b=="function"&&b()},d.send()}},Application.prototype={constructor:Application,setupCanvas:function(a){var b=this;window.addEventListener("resize",function(){b.resize(window.innerWidth,window.innerHeight)},!1),document.body.appendChild(a),this.resize(window.innerWidth,window.innerHeight);return this},resize:function(a,b){this.renderManager.resize(a,b);var c=this.camera;c.width=a,c.height=b,c.setPerspective();return this},setTitle:function(a){document.title=a;return this},onBeforeRender:function(a){},update:function(a){},capFPS:function(a){a>=60?this._nextFrame=window.requestAnimationFrame.bind(window):this._nextFrame=function(b){setTimeout(b,1e3/a)}}}